import type { ObjectDirective } from 'vue';
type TooltipValue = string | null | false | undefined;
export declare const vTooltip: ObjectDirective<TooltipElement, TooltipValue>;
declare const TooltipState: unique symbol;
interface ITooltipState {
    [TooltipState]?: VfTooltip;
}
type TooltipElement = HTMLElement & ITooltipState;
interface ITooltipOptions {
    content: string;
    title?: string;
    delay?: number;
    html?: boolean;
    class?: string | string[];
}
declare class VfTooltip {
    private el;
    private config;
    private lastMoveEvt?;
    private checkInterval?;
    private shouldShow;
    private tipEl?;
    private titleEl?;
    private contentEl?;
    private mouseMoveBound;
    private handleMouseMoveWithContext;
    private handleTargetMouseEnterWithContext;
    private handleTargetMouseLeaveWithContext;
    constructor(el: HTMLElement, config: ITooltipOptions);
    configure(config: ITooltipOptions): void;
    handleTargetMouseEnter(e: MouseEvent): void;
    handleTargetMouseLeave(): void;
    show(e?: MouseEvent): void;
    renderTooltip(): void;
    getClasses(): string[];
    removeTooltip(): void;
    handleMouseMove(e: MouseEvent): void;
    checkMoveEvent(): void;
    destroy(): void;
}
export {};
