import { type ComponentInternalInstance } from 'vue';
declare const HookState: unique symbol;
interface IHookState {
    el?: InfiniteScrollHandler;
    ancestor?: InfiniteScrollHandler;
    window?: InfiniteScrollHandler;
}
type InfiniteScrollComponent = ComponentInternalInstance & {
    [HookState]?: IHookState;
};
export interface IInfiniteScrollOptions {
    elScrolledToBottom?: () => void;
    ancestorScrolledToBottom?: () => void;
    windowScrolledToBottom?: () => void;
}
export declare function useInfiniteScroll(options: IInfiniteScrollOptions, instance?: ComponentInternalInstance): void;
export declare function installScrollHook(cmp: InfiniteScrollComponent, options: IInfiniteScrollOptions): void;
export declare function reinstallScrollHook(cmp: InfiniteScrollComponent): void;
export declare function uninstallScrollHook(cmp: InfiniteScrollComponent): void;
export declare class InfiniteScrollHandler {
    private el;
    private handler;
    isTripped: boolean;
    constructor(el: Element, handler: (e: Event) => void);
    install(): void;
    uninstall(): void;
    onScrollWithContext: (e: Event) => void;
    onScroll(e: Event): void;
}
export {};
